# ZSH Configuration

The ZSH configuration is completely modularized to make management easier. The following are brief descriptions of each
file:

* `zshrc`: The main ZSH configuration sourced for non-login interactive terminals.
* `zprofile`: The main ZSH configuration sourced for login interactive terminals. Also sources `zshrc`.
* `functions.zsh`: A file containing function definitions for utilities.
* `aliases.zsh`: A file containing aliases sourced into the terminal.
* `exports.zsh`: A file containing all exports not found in `zprofile`. 
* `initializations.zsh`: A file containing initialization code for various tasks such as RVM directories, pyenv, etc.
* `ps1.zsh`: Defines the terminal prompt.
* `keybinds.zsh`: Defines keybinds. Easier than managing a dotfile for every different system you might try.

## Special keybinds

Caps lock will be mapped to escape using `xmodmap`. You may refer to `keybinds.zsh` for more detail.

## Supported Other Files

Private variables will be automatically sourced from `$HOME/.private`,`$HOME/.bash_private` or `HOME/.zsh_private`. 

`$HOME/.inputrc` can be used for special input configurations (for example terminal editors require special terminal settings.)

Operating system specific settings can be placed in `.linuxrc` or `.macrc` respectively.

## Git Completion

Git completion is automatically installed on first run to `.zsh` in the users home. This is all created for you and nothing
needs to be done. Should the curl commands fail to pull the correct files from the `git` github repository you will need
to source both `git-completion.bash` and `git-completion.zsh` and adjust the script appropriately or place them in a 
`.zsh` directory in `$HOME`.

## Syntax Highlighting

If your ZSH version is greater than or equal to 4.11.3 fish-like syntax highlighting will be installed.

## Generators

You can generate a project for C using `cgen <project_name> <cmake_version> <standard (99, 11, etc)>`. 

## Fun 

Typing `weather` into the command line will output your local weather to the terminal.
